//+------------------------------------------------------------------+
//|                                               Reidar_EA_V7.1.mq4 |
//|                                         Developed by Coders Guru |
//|                                            http://www.xpworx.com |
//+------------------------------------------------------------------+


/*
WHAT'S NEW IN V7.1

1. stop on total profit.
Here you maybe enter a sum, wich you want to stop at. You start out at maybe 25 000$, 
and want to make 10 000. Then you could have the EA stop automatically here, at 35 000$ 
and this is the sum you enter: StopAt:$$$

2. Wait for next trade.
We should have an option when trading, where we could wait for "bars" or "time" when opening a new trade.
We use time or bars, depending on what you think is best when coding.
We open trade one, and win/lose. Now we should wait for 10 "bars" or "10 hours" befor the EA is allowed 
to open a new trade. This is kind of a MUST, in the next version. Cause I see that the EA looses often 
when it make many-trades in a small period of time.

This function should only work when WaitCross=true
The time to wait should be adjusteble offcourse.
*/

#property copyright "Reidar Fj?sne Skartun"
#property link      "http://www.xpworx.com"
extern string   ver  = "Last Modified: 2010.01.14 20:00";

#define DO_BUY 1
#define DO_SELL -1
#define DO_BUY_EXIT 1
#define DO_SELL_EXIT -1
#define DO_NOTHING 0
#define CROSS_UP 1
#define CROSS_DOWN -1
#define NO_CROSS 0
//+-------------------------------------
#define  MAX_SIZE       5
#define  sTicket        0
#define  sSymbol        1
#define  sType          2
#define  sOpenPrice     3
#define  sStopLoss      4
#define  sTakeProfit    5
#define  sMagicNumber   6
#define  sState         7
#define  State_Instant    0
#define  State_Closed     1
#define  State_Deleted    2
#define  State_TakeProfit 3
#define  State_StopLoss   4
#define  State_Modified   5

string Trades[8,MAX_SIZE];
//+-------------------------------------

extern      bool        WaitCross                        = true;
extern      int         BarsToWaitBetweenTrades          = 10;
extern      double      Lots                             = 0.1;
extern      int         TakeProfit                       = 100;
extern      int         StopLoss                         = 18;
extern      int         FirstMovingAveragePeriod         = 2;
extern      int         SecondMovingAveragePeriod        = 13;
extern      double      MinimumPipsToExit                = 5;
extern      int         ThirdMovingAveragePeriod         = 35;
extern      bool        UseMovingCrossClose              = false;
extern      bool        UseTrailingStop                  = true;
extern      int         TrailingStopValue                = 5;
extern      bool        OneTradeOnlyRunning              = true;
extern      int         ResetProgressionAtStep           = 10;

//------------------------------------------------------------

extern      double      StopAt$$$                        = 50000;

extern      double      Progression_1_Lots               = 0.2;
extern      int         Progression_1_TakeProfit         = 20;
extern      int         Progression_1_StopLoss           = 18;

extern      double      Progression_2_Lots               = 0.4;
extern      int         Progression_2_TakeProfit         = 20;
extern      int         Progression_2_StopLoss           = 18;

extern      double      Progression_3_Lots               = 0.8;
extern      int         Progression_3_TakeProfit         = 20;
extern      int         Progression_3_StopLoss           = 18;

extern      double      Progression_4_Lots               = 1.6;
extern      int         Progression_4_TakeProfit         = 20;
extern      int         Progression_4_StopLoss           = 18;

extern      double      Progression_5_Lots               = 3.2;
extern      int         Progression_5_TakeProfit         = 20;
extern      int         Progression_5_StopLoss           = 18;

extern      double      Progression_6_Lots               = 6.4;
extern      int         Progression_6_TakeProfit         = 20;
extern      int         Progression_6_StopLoss           = 18;

extern      double      Progression_7_Lots               = 12.8;
extern      int         Progression_7_TakeProfit         = 20;
extern      int         Progression_7_StopLoss           = 18;

extern      double      Progression_8_Lots               = 25.6;
extern      int         Progression_8_TakeProfit         = 20;
extern      int         Progression_8_StopLoss           = 18;

extern      double      Progression_9_Lots               = 51.2;
extern      int         Progression_9_TakeProfit         = 20;
extern      int         Progression_9_StopLoss           = 18;

extern      double      Progression_10_Lots              = 0;
extern      int         Progression_10_TakeProfit        = 20;
extern      int         Progression_10_StopLoss          = 18;

extern      double      Progression_11_Lots              = 0;
extern      int         Progression_11_TakeProfit        = 20;
extern      int         Progression_11_StopLoss          = 18;

extern      double      Progression_12_Lots              = 0;
extern      int         Progression_12_TakeProfit        = 20;
extern      int         Progression_12_StopLoss          = 18;

extern      double      Progression_13_Lots              = 0;
extern      int         Progression_13_TakeProfit        = 20;
extern      int         Progression_13_StopLoss          = 18;

extern      double      Progression_14_Lots              = 0;
extern      int         Progression_14_TakeProfit        = 20;
extern      int         Progression_14_StopLoss          = 18;

extern      double      Progression_15_Lots              = 0;
extern      int         Progression_15_TakeProfit        = 20;
extern      int         Progression_15_StopLoss          = 18;

extern      double      Progression_16_Lots              = 0;
extern      int         Progression_16_TakeProfit        = 20;
extern      int         Progression_16_StopLoss          = 18;

extern      double      Progression_17_Lots              = 0;
extern      int         Progression_17_TakeProfit        = 20;
extern      int         Progression_17_StopLoss          = 18;

extern      double      Progression_18_Lots              = 0;
extern      int         Progression_18_TakeProfit        = 20;
extern      int         Progression_18_StopLoss          = 18;

extern      double      Progression_19_Lots              = 0;
extern      int         Progression_19_TakeProfit        = 20;
extern      int         Progression_19_StopLoss          = 18;

extern      double      Progression_20_Lots              = 0;
extern      int         Progression_20_TakeProfit        = 20;
extern      int         Progression_20_StopLoss          = 18;

extern      double      Progression_21_Lots              = 0;
extern      int         Progression_21_TakeProfit        = 20;
extern      int         Progression_21_StopLoss          = 18;

extern      double      Progression_22_Lots              = 0;
extern      int         Progression_22_TakeProfit        = 20;
extern      int         Progression_22_StopLoss          = 18;

extern      double      Progression_23_Lots              = 0;
extern      int         Progression_23_TakeProfit        = 20;
extern      int         Progression_23_StopLoss          = 18;

extern      double      Progression_24_Lots              = 0;
extern      int         Progression_24_TakeProfit        = 20;
extern      int         Progression_24_StopLoss          = 18;

extern      double      Progression_25_Lots              = 0;
extern      int         Progression_25_TakeProfit        = 20;
extern      int         Progression_25_StopLoss          = 18;

extern      double      Progression_26_Lots              = 0;
extern      int         Progression_26_TakeProfit        = 20;
extern      int         Progression_26_StopLoss          = 18;

extern      double      Progression_27_Lots              = 0;
extern      int         Progression_27_TakeProfit        = 20;
extern      int         Progression_27_StopLoss          = 18;

extern      double      Progression_28_Lots              = 0;
extern      int         Progression_28_TakeProfit        = 20;
extern      int         Progression_28_StopLoss          = 18;

extern      double      Progression_29_Lots              = 0;
extern      int         Progression_29_TakeProfit        = 20;
extern      int         Progression_29_StopLoss          = 18;

extern      double      Progression_30_Lots              = 0;
extern      int         Progression_30_TakeProfit        = 20;
extern      int         Progression_30_StopLoss          = 18;

//-----------------------------------------------
//--- Global variables
string   ExpertName        = "Reidar_EA_V7.1";
double   mPoint            = 0.0001;
int      MagicNumber       = 98765;
datetime LastCrossBar      = 0;

int LastProgression = 0;
double cLots = 0;
int cTakeProfit = 0;
int cStopLoss = 0;

datetime LastTradeTime = 0;
int LastTradeBar = 0;

double StarterBalance = 0;
bool Stopped = false;

//+-------------------------------------
void Add(string iTicket, string iSymbol, string iType, string iOpenPrice,
string iStopLoss, string iTakeProfit, string iMagicNumber, string iState)
{
   for (int cnt = 1 ; cnt < MAX_SIZE ; cnt++)
   {
      for(int c = 0 ; c < 8 ; c++) Trades[c][cnt] = Trades[c][cnt-1];
   }
   
   if(StrToInteger(iType)==OP_BUY)
   {
      if(StrToDouble(iTakeProfit)>0) Trades[sTakeProfit][0]=StrToDouble(iOpenPrice) + StrToDouble(iTakeProfit)*mPoint; 
      if(StrToDouble(iStopLoss)>0) Trades[sStopLoss][0]=StrToDouble(iOpenPrice) - StrToDouble(iStopLoss)*mPoint; 
   }
   
   if(StrToInteger(iType)==OP_SELL)
   {
      if(StrToDouble(iTakeProfit)>0) Trades[sTakeProfit][0]=StrToDouble(iOpenPrice) - StrToDouble(iTakeProfit)*mPoint; 
      if(StrToDouble(iStopLoss)>0) Trades[sStopLoss][0]=StrToDouble(iOpenPrice) + StrToDouble(iStopLoss)*mPoint; 
   }
   
   Trades[sTicket][0]=iTicket; 
   Trades[sSymbol][0]=iSymbol; 
   Trades[sType][0]=iType; 
   Trades[sOpenPrice][0]=iOpenPrice; 
   Trades[sMagicNumber][0]=iMagicNumber; 
   Trades[sState][0]=iState; 
}

void Modify(string iTicket, string iSymbol, string iType, string iOpenPrice,
string iStopLoss, string iTakeProfit, string iMagicNumber, string iState)
{
   for (int cnt = 0 ; cnt < MAX_SIZE ; cnt++)
   {
      if(Trades[sTicket][cnt]==iTicket)
      {
         if(iTicket!="")Trades[sTicket][cnt]=iTicket; 
         if(iSymbol!="")Trades[sSymbol][cnt]=iSymbol; 
         if(iType!="")Trades[sType][cnt]=iType; 
         if(iOpenPrice!="")Trades[sOpenPrice][cnt]=iOpenPrice; 
         if(iStopLoss!="")Trades[sStopLoss][cnt]=iStopLoss; 
         if(iTakeProfit!="")Trades[sTakeProfit][cnt]=iTakeProfit; 
         if(iMagicNumber!="")Trades[sMagicNumber][cnt]=iMagicNumber; 
         if(iState!="")Trades[sState][cnt]=iState; 
      }
   }
}

string OrderGet(string iTicket,int index)
{   
   for (int cnt = 0 ; cnt < MAX_SIZE ; cnt++)
   {
      if(Trades[sTicket][cnt]==iTicket)
      {
         return(Trades[index][cnt]); 
      }
   }
}

void Load(int magic)
{
   for (int a=0; a<8; a++)
   {
      for(int b=0; b<MAX_SIZE; b++)
      {
         Trades[a,b] = EMPTY_VALUE;  
      }
   }

   for(int cnt=0; cnt< OrdersTotal(); cnt++)
   {
      OrderSelect(cnt,MODE_TRADES);
      if(OrderMagicNumber()==MagicNumber)
      {
         Add(OrderTicket(),Symbol(),OrderType(),OrderOpenPrice(),StopLoss,TakeProfit,OrderMagicNumber(),State_Instant);
      }
   }          
}
//-------------------------------------------
int Simulate()
{
   int tick = 0;
   for(int cnt = 0; cnt < MAX_SIZE; cnt++)
   {
      if(Trades[sTicket,cnt]=="2147483647") continue;
      
      if(StrToInteger(Trades[sType,cnt])==OP_BUY && StrToInteger(Trades[sState,cnt])==State_Instant)
      {
         if(Bid>=StrToDouble(Trades[sTakeProfit,cnt]) && StrToDouble(Trades[sTakeProfit,cnt])>0)
         {
            Modify(Trades[sTicket,cnt],"","","","","","",State_TakeProfit);
            OnTakeProfit(Trades[sTicket,cnt]); 
         }
         if(Bid<=StrToDouble(Trades[sStopLoss,cnt]) && StrToDouble(Trades[sStopLoss,cnt])>0)
         {
            Modify(Trades[sTicket,cnt],"","","","","","",State_StopLoss);
            OnStopLoss(Trades[sTicket,cnt]);
         }
      }
      
      if(StrToInteger(Trades[sType,cnt])==OP_SELL && StrToInteger(Trades[sState,cnt])==State_Instant)
      {
         if(Ask<=StrToDouble(Trades[sTakeProfit,cnt]) && StrToDouble(Trades[sTakeProfit,cnt])>0)
         {
            Modify(Trades[sTicket,cnt],"","","","","","",State_TakeProfit);
            OnTakeProfit(Trades[sTicket,cnt]); 
         }
         if(Ask>=StrToDouble(Trades[sStopLoss,cnt]) && StrToDouble(Trades[sStopLoss,cnt])>0)
         {
            Modify(Trades[sTicket,cnt],"","","","","","",State_StopLoss);
            OnStopLoss(Trades[sTicket,cnt]);
         }
      }      
   }
   return(0);
}
//-------------------------------------------
void OnStopLoss(string tick)
{
   //place your OnStopLoss code here
   Print("Order #",tick, " closed by StopLoss");
   LastProgression = LastProgression + 1;
   CheckProgression();
   if(WaitCross==false) 
   {
      int TradeType = StrToInteger(OrderGet(tick,sType));
      int ticket = OpenOrder(Symbol(),TradeType,cLots,5,cStopLoss,cTakeProfit,MagicNumber,ExpertName,5);
      LastTradeTime = TimeCurrent(); 
      if(ticket>-1)
      {
         if(TradeType==OP_BUY) Add(tick,Symbol(),OP_BUY,Ask,cStopLoss,cTakeProfit,MagicNumber,State_Instant);
         if(TradeType==OP_SELL) Add(tick,Symbol(),OP_SELL,Bid,cStopLoss,cTakeProfit,MagicNumber,State_Instant);
      }
   }
}
//-------------------------------------------
void OnTakeProfit(string tick)
{
   //place your OnTakeProfit code here
   Print("Order #",tick, " closed by TakeProfit");
   LastProgression = 0;
}
//-------------------------------------------

int init()
{
   if(Point==0.00001) mPoint=0.0001;
   else if(Point==0.001) mPoint=0.01;
   else mPoint = Point;
   
   Load(MagicNumber);   
         
   return(0);
}

int deinit()
{
   return(0);
}

void CheckProgression()
{
  
   if(LastProgression>ResetProgressionAtStep) LastProgression = 0;
   
   switch(LastProgression)
   {
      case 0:
      {
         if(Lots>0)
         {
            cLots = Lots;
            cTakeProfit = TakeProfit;
            cStopLoss = StopLoss;
         }
         break;
      }
      case 1:
      {
         if(Progression_1_Lots>0)
         {
            cLots = Progression_1_Lots;
            cTakeProfit = Progression_1_TakeProfit;
            cStopLoss = Progression_1_StopLoss;
         }
         break;
      }
      case 2:
      {
         if(Progression_2_Lots>0)
         {
            cLots = Progression_2_Lots;
            cTakeProfit = Progression_2_TakeProfit;
            cStopLoss = Progression_2_StopLoss;
         }
         break;
      }
      case 3:
      {
         if(Progression_3_Lots>0)
         {     
            cLots = Progression_3_Lots;
            cTakeProfit = Progression_3_TakeProfit;
            cStopLoss = Progression_3_StopLoss;
         }
         break;
      }
      case 4:
      {
         if(Progression_4_Lots>0)
         {
            cLots = Progression_4_Lots;
            cTakeProfit = Progression_4_TakeProfit;
            cStopLoss = Progression_4_StopLoss;
         }
         break;
      }
      case 5:
      {
         if(Progression_5_Lots>0)
         {
            cLots = Progression_5_Lots;
            cTakeProfit = Progression_5_TakeProfit;
            cStopLoss = Progression_5_StopLoss;
         }
         break;
      }
      case 6:
      {
         if(Progression_6_Lots>0)
         {
            cLots = Progression_6_Lots;
            cTakeProfit = Progression_6_TakeProfit;
            cStopLoss = Progression_6_StopLoss;
         }
         break;
      }
      case 7:
      {
         if(Progression_7_Lots>0)
         {
            cLots = Progression_7_Lots;
            cTakeProfit = Progression_7_TakeProfit;
            cStopLoss = Progression_7_StopLoss;
         }
         break;
      }
      case 8:
      {
         if(Progression_8_Lots>0)
         {
            cLots = Progression_8_Lots;
            cTakeProfit = Progression_8_TakeProfit;
            cStopLoss = Progression_18_StopLoss;
         }
         break;
      }
      case 9:
      {
         if(Progression_9_Lots>0)
         {
            cLots = Progression_9_Lots;
            cTakeProfit = Progression_9_TakeProfit;
            cStopLoss = Progression_9_StopLoss;
         }
         break;
      }
      case 10:
      {
         if(Progression_10_Lots>0)
         {
            cLots = Progression_10_Lots;
            cTakeProfit = Progression_10_TakeProfit;
            cStopLoss = Progression_10_StopLoss;
         }
         break;
      }
      case 11:
      {
         if(Progression_11_Lots>0)
         {
            cLots = Progression_11_Lots;
            cTakeProfit = Progression_11_TakeProfit;
            cStopLoss = Progression_11_StopLoss;
         }
         break;
      }
      case 12:
      {
         if(Progression_12_Lots>0)
         {
            cLots = Progression_12_Lots;
            cTakeProfit = Progression_12_TakeProfit;
            cStopLoss = Progression_12_StopLoss;
         }
         break;
      }
      case 13:
      {
         if(Progression_13_Lots>0)
         {
            cLots = Progression_13_Lots;
            cTakeProfit = Progression_13_TakeProfit;
            cStopLoss = Progression_13_StopLoss;
         }
         break;
      }
      case 14:
      {
         if(Progression_14_Lots>0)
         {
            cLots = Progression_14_Lots;
            cTakeProfit = Progression_14_TakeProfit;
            cStopLoss = Progression_14_StopLoss;
         }
         break;
      }
      case 15:
      {
         if(Progression_15_Lots>0)
         {
            cLots = Progression_15_Lots;
            cTakeProfit = Progression_15_TakeProfit;
            cStopLoss = Progression_15_StopLoss;
         }
         break;
      }
      case 16:
      {
         if(Progression_16_Lots>0)
         {
            cLots = Progression_16_Lots;
            cTakeProfit = Progression_16_TakeProfit;
            cStopLoss = Progression_16_StopLoss;
         }
         break;
      }
      case 17:
      {
         if(Progression_17_Lots>0)
         {
            cLots = Progression_17_Lots;
            cTakeProfit = Progression_17_TakeProfit;
            cStopLoss = Progression_17_StopLoss;
         }
         break;
      }
      case 18:
      {
         if(Progression_18_Lots>0)
         {
            cLots = Progression_18_Lots;
            cTakeProfit = Progression_18_TakeProfit;
            cStopLoss = Progression_18_StopLoss;
         }
         break;
      }
      case 19:
      {
         if(Progression_19_Lots>0)
         {
            cLots = Progression_19_Lots;
            cTakeProfit = Progression_19_TakeProfit;
            cStopLoss = Progression_19_StopLoss;
         }
         break;
      }
      case 20:
      {
         if(Progression_20_Lots>0)
         {
            cLots = Progression_20_Lots;
            cTakeProfit = Progression_20_TakeProfit;
            cStopLoss = Progression_20_StopLoss;
         }
         break;
      }
      case 21:
      {
         if(Progression_21_Lots>0)
         {
            cLots = Progression_21_Lots;
            cTakeProfit = Progression_21_TakeProfit;
            cStopLoss = Progression_21_StopLoss;
         }
         break;
      }
      case 22:
      {
         if(Progression_22_Lots>0)
         {
            cLots = Progression_22_Lots;
            cTakeProfit = Progression_22_TakeProfit;
            cStopLoss = Progression_22_StopLoss;
         }
         break;
      }
      case 23:
      {
         if(Progression_23_Lots>0)
         {
            cLots = Progression_23_Lots;
            cTakeProfit = Progression_23_TakeProfit;
            cStopLoss = Progression_23_StopLoss;
         }
         break;
      }
      case 24:
      {
         if(Progression_24_Lots>0)
         {
            cLots = Progression_24_Lots;
            cTakeProfit = Progression_24_TakeProfit;
            cStopLoss = Progression_24_StopLoss;
         }
         break;
      }
      case 25:
      {
         if(Progression_25_Lots>0)
         {
            cLots = Progression_25_Lots;
            cTakeProfit = Progression_25_TakeProfit;
            cStopLoss = Progression_25_StopLoss;
         }
         break;
      }
      case 26:
      {
         if(Progression_26_Lots>0)
         {
            cLots = Progression_26_Lots;
            cTakeProfit = Progression_26_TakeProfit;
            cStopLoss = Progression_26_StopLoss;
         }
         break;
      }
      case 27:
      {
         if(Progression_27_Lots>0)
         {
            cLots = Progression_27_Lots;
            cTakeProfit = Progression_27_TakeProfit;
            cStopLoss = Progression_27_StopLoss;
         }
         break;
      }
      case 28:
      {
         if(Progression_28_Lots>0)
         {
            cLots = Progression_28_Lots;
            cTakeProfit = Progression_28_TakeProfit;
            cStopLoss = Progression_28_StopLoss;
         }
         break;
      }
      case 29:
      {
         if(Progression_29_Lots>0)
         {
            cLots = Progression_29_Lots;
            cTakeProfit = Progression_29_TakeProfit;
            cStopLoss = Progression_29_StopLoss;
         }
         break;
      }
      case 30:
      {
         if(Progression_20_Lots>0)
         {
            cLots = Progression_30_Lots;
            cTakeProfit = Progression_30_TakeProfit;
            cStopLoss = Progression_30_StopLoss;
         }
         break;
      }
   }
}

int start()
{
   
   if(Stopped == true && isNewSymbol(Symbol(),MagicNumber)) return(0);
   
   if(isNewSymbol(Symbol(),MagicNumber)) StarterBalance = AccountBalance();

   Simulate();
   
   int Signal = 0, Exit = 0;
   Exit = CheckExit();
   Signal = CheckSignal();
   
   CheckProgression();
   
   bool BuyCondition = false , SellCondition = false, ExitBuyCondition = false , ExitSellCondition = false;
   
   if (Signal == DO_BUY)
   { 
      BuyCondition = true;
   }
   
   if (Signal == DO_SELL) 
   { 
      SellCondition = true;
   }
   
   if (Exit == DO_BUY_EXIT)
   { 
      ExitBuyCondition = true;
   }
   
   if (Exit == DO_SELL_EXIT) 
   { 
      ExitSellCondition = true;
   }

   for(int cnt = 0 ; cnt < OrdersTotal() ; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber()== MagicNumber)
      {
         if(ExitBuyCondition && OrderType()==OP_BUY && Profit(OrderType(), 
         OrderSymbol(),OrderOpenPrice())>=MinimumPipsToExit && LastProgression == 0 && UseMovingCrossClose==true /*&& UseTrailingStop==false*/)
         {
            OrderClose(OrderTicket(),OrderLots(),Bid,5,Violet);
            Modify(OrderTicket(),"","","","","","",State_Closed);
         }
         if(ExitSellCondition && OrderType()==OP_SELL && Profit(OrderType(), 
         OrderSymbol(),OrderOpenPrice())>=MinimumPipsToExit && LastProgression == 0 && UseMovingCrossClose==true /*&& UseTrailingStop==false*/)
         {
            OrderClose(OrderTicket(),OrderLots(),Ask,5,Violet);
            Modify(OrderTicket(),"","","","","","",State_Closed);
         }
         if(UseTrailingStop==true /*&& UseMovingCrossClose==false*/ && LastProgression == 0) 
         {
            TrailOrder(OrderType());
         }
      }
    }

   int CrossBar = 0;
   if(LastCrossBar==0) CrossBar = 1;
   else CrossBar = iBarShift(NULL,0,LastCrossBar,true);
   
   int tick = 0;
   if(OneTradeOnlyRunning)
   {
      if(OrdersTotal() < 1 || isNewSymbol(Symbol(),MagicNumber)) 
      {
        LastTradeBar = iBarShift(NULL,0,LastTradeTime,false);
        if(BuyCondition && (WaitCross==false || (WaitCross==true && LastTradeBar>=BarsToWaitBetweenTrades))) //<-- BUY condition
        {
            if(WaitCross==false) LastProgression = 0;
            tick = OpenOrder(Symbol(),OP_BUY,cLots,5,cStopLoss,cTakeProfit,MagicNumber,ExpertName,5);
            LastTradeTime = TimeCurrent();
            if(tick>-1) Add(tick,Symbol(),OP_BUY,Ask,cStopLoss,cTakeProfit,MagicNumber,State_Instant);
        }
        if(SellCondition  && (WaitCross==false || (WaitCross==true && LastTradeBar>=BarsToWaitBetweenTrades))) //<-- SELL condition
        {
            if(WaitCross==false) LastProgression = 0;
            tick = OpenOrder(Symbol(),OP_SELL,cLots,5,cStopLoss,cTakeProfit,MagicNumber,ExpertName,5);
            LastTradeTime = TimeCurrent();
            if(tick>-1) Add(tick,Symbol(),OP_SELL,Bid,cStopLoss,cTakeProfit,MagicNumber,State_Instant);
        }  
      }
   }
   else
   {
      //Multi trades ....
   }
   
   if(StopAt$$$>0) MonitorOverAllProfit();
   
   Simulate();
   
   return(0);
}

void MonitorOverAllProfit()
{
            
   if(AccountEquity()>=StopAt$$$) 
   {
      Print("Let's take the profit");
      CloseAll(MagicNumber);
      Stopped=true;
   }
}

void TrailOrder(int type)
{
   if(TrailingStopValue>0)
   {
      if(OrderMagicNumber() == MagicNumber)
      {
         if(type==OP_BUY)
         {
            if(Bid-OrderOpenPrice()>mPoint*TrailingStopValue)
            {
               if(OrderStopLoss()<Bid-mPoint*TrailingStopValue)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-mPoint*TrailingStopValue,OrderTakeProfit(),0,Green);
                  Modify(OrderTicket(),"","","",Bid-mPoint*TrailingStopValue,"","",State_Modified);
               }
            }
         }
         if(type==OP_SELL)
         {
            if(OrderOpenPrice()-Ask>mPoint*TrailingStopValue)
            {
               if(OrderStopLoss()>Ask+mPoint*TrailingStopValue)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask+mPoint*TrailingStopValue,OrderTakeProfit(),0,Red);
                  Modify(OrderTicket(),"","","",Ask+mPoint*TrailingStopValue,"","",State_Modified);
               }
            }
         }
      }
   }
}

int Cross(double value_1_cur, double value_2_cur, double value_1_prev, double value_2_prev)
{
   if(value_1_cur>value_2_cur && value_1_prev<value_2_prev) 
   {
      LastCrossBar=TimeCurrent();
      return(CROSS_UP);
   }
   if(value_1_cur<value_2_cur && value_1_prev>value_2_prev) 
   {
      LastCrossBar=TimeCurrent();
      return(CROSS_DOWN);
   }
   
   return(NO_CROSS);
}

int CheckExit()
{
   double First_MA_Cur = iMA(NULL,0,FirstMovingAveragePeriod,0,MODE_EMA,PRICE_CLOSE,0);
   double First_MA_Prev = iMA(NULL,0,FirstMovingAveragePeriod,0,MODE_EMA,PRICE_CLOSE,1);
   double Second_MA_Cur = iMA(NULL,0,SecondMovingAveragePeriod,0,MODE_EMA,PRICE_CLOSE,0);
   double Second_MA_Prev = iMA(NULL,0,SecondMovingAveragePeriod,0,MODE_EMA,PRICE_CLOSE,1);
   
   if(FirstMovingAveragePeriod==0) 
   {
      if(Open[0]>Second_MA_Cur && Close[0]<Second_MA_Cur) return(DO_BUY_EXIT);
      if(Open[0]<Second_MA_Cur && Close[0]>Second_MA_Cur) return(DO_SELL_EXIT);
   }
   else
   {
      if(Cross(First_MA_Cur,Second_MA_Cur,First_MA_Prev,Second_MA_Prev)==CROSS_UP) return(DO_SELL_EXIT);
      if(Cross(First_MA_Cur,Second_MA_Cur,First_MA_Prev,Second_MA_Prev)==CROSS_DOWN) return(DO_BUY_EXIT);
   }
   
   return(DO_NOTHING);    
}
int CheckSignal()
{
   double First_MA_Cur = iMA(NULL,0,FirstMovingAveragePeriod,0,MODE_EMA,PRICE_CLOSE,0);
   double First_MA_Prev = iMA(NULL,0,FirstMovingAveragePeriod,0,MODE_EMA,PRICE_CLOSE,1);
   double Third_MA_Cur = iMA(NULL,0,ThirdMovingAveragePeriod,0,MODE_EMA,PRICE_CLOSE,0);
   double Third_MA_Prev = iMA(NULL,0,ThirdMovingAveragePeriod,0,MODE_EMA,PRICE_CLOSE,1);
   
   if(FirstMovingAveragePeriod==0) 
   {
      if(Open[0]>Third_MA_Cur && Close[0]<Third_MA_Cur) return(DO_SELL);
      if(Open[0]<Third_MA_Cur && Close[0]>Third_MA_Cur) return(DO_BUY);
      
   }
   else
   {
      if(Cross(First_MA_Cur,Third_MA_Cur,First_MA_Prev,Third_MA_Prev)==CROSS_UP) return(DO_BUY);
      if(Cross(First_MA_Cur,Third_MA_Cur,First_MA_Prev,Third_MA_Prev)==CROSS_DOWN) return(DO_SELL);
   }
   
   return(DO_NOTHING);    
}

bool isNewSymbol(string current_symbol, int magic)
{
   int total  = OrdersTotal();
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      string selected_symbol = OrderSymbol();
      if (current_symbol == selected_symbol && OrderMagicNumber()== magic)
      return (False);
    }
    return (True);
}

int OpenOrder(string TradeSymbol, int TradeType, double TradeLot, int TradeSlippage, int TradeStopLoss, int TradeTakeProfit, int TradeMagic, string TradeComment = "", int TriesCount = 5)
{
   int ticket=0;
   int err=0;
   int num = 0;
   
   RefreshRates();
   double pt = mPoint;//MarketInfo(TradeSymbol,MODE_POINT);
   double ask = MarketInfo(TradeSymbol,MODE_ASK);
   double bid = MarketInfo(TradeSymbol,MODE_BID);
   
   if(TradeType == OP_BUY)
   {
      for(num = 0 ; num < TriesCount ; num++)
      {
         if(TradeStopLoss>0 && TradeTakeProfit>0)
            ticket=OrderSend(TradeSymbol,OP_BUY,TradeLot,ask,TradeSlippage,ask-TradeStopLoss*pt,ask+TradeTakeProfit*pt,TradeComment,TradeMagic,0,Green);
         if(TradeStopLoss==0 && TradeTakeProfit==0)
            ticket=OrderSend(TradeSymbol,OP_BUY,TradeLot,ask,TradeSlippage,0,0,TradeComment,TradeMagic,0,Green);
         if(TradeStopLoss>0 && TradeTakeProfit==0)
            ticket=OrderSend(TradeSymbol,OP_BUY,TradeLot,ask,TradeSlippage,ask-TradeStopLoss*pt,0,TradeComment,TradeMagic,0,Green);
         if(TradeStopLoss==0 && TradeTakeProfit>0)
            ticket=OrderSend(TradeSymbol,OP_BUY,TradeLot,ask,TradeSlippage,0,ask+TradeTakeProfit*pt,TradeComment,TradeMagic,0,Green);
         
         err=GetLastError();
         if(err==4 || err==6 || err==8 || err==128 || err==129 || err==135 || err==136 || err==137 || err==138 || err==141 || err==146)
         { 
            Sleep(5000);
            continue;
         }
         else
         {
            break;
         }
      }   
   }
   
   if(TradeType == OP_SELL)
   {   
      for(num = 0 ; num < TriesCount ; num++)
      {
         if(TradeStopLoss>0 && TradeTakeProfit>0)
            ticket=OrderSend(TradeSymbol,OP_SELL,TradeLot,bid,TradeSlippage,bid+TradeStopLoss*pt,bid-TradeTakeProfit*pt,TradeComment,TradeMagic,0,Red);
         if(TradeStopLoss==0 && TradeTakeProfit==0)
            ticket=OrderSend(TradeSymbol,OP_SELL,TradeLot,bid,TradeSlippage,0,0,TradeComment,TradeMagic,0,Red);
         if(TradeStopLoss>0 && TradeTakeProfit==0)
            ticket=OrderSend(TradeSymbol,OP_SELL,TradeLot,bid,TradeSlippage,bid+TradeStopLoss*pt,0,TradeComment,TradeMagic,0,Red);
         if(TradeStopLoss==0 && TradeTakeProfit>0)
            ticket=OrderSend(TradeSymbol,OP_SELL,TradeLot,bid,TradeSlippage,0,bid-TradeTakeProfit*pt,TradeComment,TradeMagic,0,Red);

         err=GetLastError();
         if(err==4 || err==6 || err==8 || err==128 || err==129 || err==135 || err==136 || err==137 || err==138 || err==141 || err==146)
         { 
            Sleep(5000);
            continue;
         }
         else
         {
            break;
         }
      }   
   }  
   return(ticket);
}

double Profit(int type, string currency,  double open)
{
   RefreshRates();
   double ask = MarketInfo(currency,MODE_ASK);
   double bid = MarketInfo(currency,MODE_BID);
   double pt = mPoint; //MarketInfo(currency,MODE_POINT);
   double sp = (ask - bid)/pt;
   if(type==OP_BUY) Comment("Profit = ",((ask - open)/pt) -sp);
   if(type ==OP_SELL) Comment("Profit = ",((open - bid)/pt) -sp);
   if(OrdersTotal()==0) Comment("Profit = 0");
   if(type==OP_BUY) return(((ask - open)/pt) -sp); 
   if(type ==OP_SELL) return(((open - bid)/pt) -sp);
   return(-1);
}

int CloseAll(int magic)
{
   int total = OrdersTotal();
   int cnt = 0;
   RefreshRates();
   for (cnt = 0 ; cnt <total ; cnt++)
   {
      OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == magic)
      {
         if(OrderType()==OP_BUY)
         {
            OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
            Modify(OrderTicket(),"","","","","","",State_Closed);
         }
         if(OrderType()==OP_SELL)
         { 
            OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
            Modify(OrderTicket(),"","","","","","",State_Closed);
         }
         if(OrderType()>OP_SELL)
         {
            OrderDelete(OrderTicket());
            Modify(OrderTicket(),"","","","","","",State_Deleted);
         }
      }
  }         
}


